public class ArrayDatabaseTest
{
  public static void main(String[] args)
  {
    ArrayMemoDatabase m = new ArrayMemoDatabase();
    MemoAssociation eugene = new MemoAssociation("Eugene", "Kurt Vonnegut");
    
    System.out.println( m.insert(eugene) );                        // true
    System.out.println( m.containsKey("Eugene") );                 // true
    System.out.println( m.containsKey("Kurt") );                   // false
    
    System.out.println( m.find("Eugene") );                        // "Kurt Vonnegut"
    System.out.println( m.find("Kurt") );                          // null

    MemoAssociation kurt = new MemoAssociation("Kurt", "Joseph Heller");
    System.out.println( m.insert(kurt) );                          // true
    System.out.println( m.containsKey("Kurt") );                   // true 
    System.out.println( m.find("Kurt") );                          // "Joseph Heller"
    System.out.println( m.find("Eugene") );                        // "Kurt Vonnegut"

    System.out.println( m.remove("Eugene") );                      // true
    System.out.println( m.find("Eugene") );                        // null
    System.out.println( m.find("Kurt") );                          // "Joseph Heller"

    MemoAssociation duplicate = new MemoAssociation("Eugene", "Franz Kafka");
    System.out.println( m.insert(eugene) );                        // true
    System.out.println( m.insert(duplicate) );                     // false
    System.out.println( m.find("Eugene") );                        // "Kurt Vonnegut"

    // test full array
    m = new ArrayMemoDatabase();
    for (int i=0; i < 10; i++)
      m.insert( new MemoAssociation("key"+i, "value"+i) );
    System.out.println( m.insert(eugene) );                        // false
    System.out.println( m.find("Eugene") );                        // null
    System.out.println( m.find("key9") );                          // "value9"
  }
}